/* libunwind - a platform-independent unwind library
   Copyright (C) 2008 CodeSourcery
   Copyright (C) 2012 Tommi Rantala <tt.rantala@gmail.com>

This file is part of libunwind.

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.  */

#include "offsets.h"
#include <endian.h>

	.text
#define OFFSET 80
	.global _Usw_64_getcontext
	.type	_Usw_64_getcontext, %function
	.ent _Usw_64_getcontext
	# This is a stub version of getcontext() for SW_64 which only stores core
	# registers.
_Usw_64_getcontext:
	.set noat
	stl	$0, (0 + OFFSET)($16)
	stl	$1, (8 + OFFSET)($16)
	stl	$2, (16 + OFFSET)($16)
	stl	$3, (24 + OFFSET)($16)
	stl	$4, (32 + OFFSET)($16)
	stl	$5, (40 + OFFSET)($16)
	stl	$6, (48 + OFFSET)($16)
	stl	$7, (56 + OFFSET)($16)
	stl	$8, (64 + OFFSET)($16)
	stl	$9, (72 + OFFSET)($16)
	stl	$10, (80 + OFFSET)($16)
	stl	$11, (88 + OFFSET)($16)
	stl	$12, (96 + OFFSET)($16)
	stl	$13, (104 + OFFSET)($16)
	stl	$14, (112 + OFFSET)($16)
	stl	$15, (120 + OFFSET)($16)
	stl	$16, (128 + OFFSET)($16)
	stl	$17, (136 + OFFSET)($16)
	stl	$18, (144 + OFFSET)($16)
	stl	$19, (152 + OFFSET)($16)
	stl	$20, (160 + OFFSET)($16)
	stl	$21, (168 + OFFSET)($16)
	stl	$22, (176 + OFFSET)($16)
	stl	$23, (184 + OFFSET)($16)
	stl	$24, (192 + OFFSET)($16)
	stl	$25, (200 + OFFSET)($16)
	stl	$26, (208 + OFFSET)($16)
	stl	$27, (216 + OFFSET)($16)
	stl	$28, (224 + OFFSET)($16)
	stl	$29, (232 + OFFSET)($16)
	stl	$30, (240 + OFFSET)($16)
	stl	$31, (248 + OFFSET)($16)
#	br $0,2f
2:
#	stl $0, (OFFSET-16)($16)
	stl $26, (OFFSET-16)($16)
	ldl $0, (0 + OFFSET)($16)
	ret
	.end _Usw_64_getcontext
	.size	_Usw_64_getcontext, .-_Usw_64_getcontext
